﻿@*
    For more information on enabling MVC for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860
*@
@{
	@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
}
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>
    function showProductDetail(productId) {
        $.ajax({
            url: '/Index/GetProductDetail',
            type: 'GET',
            data: { productId: productId },
            success: function(data) {
                $('#productId').val(data.productId);
                $('#productName').val(data.productName);
                $('#productPrice').val(data.unitPrice);
                $('#productStock').val(data.unitsInStock);
                $('#productImage').val(data.image);
                $('#categorySelect').val(data.categoryId);
            },
            error: function() {
                alert('Error fetching product details.');
            }
        });
    }

	function deleteProduct(productId) {
		if (confirm('Are you sure you want to delete this product?')) {
			$.ajax({
				url: '/Index/DeleteProduct',
				type: 'POST',
				data: { productId: productId },
				success: function() {
					alert('Product deleted successfully.');
					location.reload();
				},
				error: function() {
					alert('Error deleting product.');
				}
			});
		}
	}

	function addProduct(){
		var productId = $('#productId').val();
		var productName = $('#productName').val();
		var productPrice = $('#productPrice').val();
		var productStock = $('#productStock').val();
		var productImage = $('#productImage').val();
		var categoryId = $('#categorySelect').val();

        $.ajax({
            url: '/Index/AddProduct',
            type: 'POST',
            data: {
                productName: productName,
                productPrice: productPrice,
                productStock: productStock,
                productImage: productImage,
                categoryId: categoryId
            },
            success: function() {
                alert('Product added successfully.');
				location.reload();
            },
            error: function() {
                alert('Error adding product.');
            }
        });
	}

	function updateProduct(){
		var productId = $('#productId').val();
		var productName = $('#productName').val();
		var productPrice = $('#productPrice').val();
		var productStock = $('#productStock').val();
		var productImage = $('#productImage').val();
		var categoryId = $('#categorySelect').val();

        $.ajax({
            url: '/Index/UpdateProduct',
            type: 'POST',
            data: {
                productName: productName,
                productPrice: productPrice,
                productStock: productStock,
                productImage: productImage,
                categoryId: categoryId
            },
            success: function() {
                alert('Product updated successfully.');
				location.reload();
            },
            error: function() {
                alert('Error updated product.');
            }
        });
	}

	function filter(){
		var categoryId = document.getElementById("categoryFilter").value;
		$.ajax({
            url: '/Index/Index',
            type: 'GET',
            data: { categoryFilter : categoryId },
            success: function(data) {
				 $('#productTableBody').html(data);
            },
            error: function() {
                alert('Error filter.');
            }
        });
	}

</script>
<h1>List category</h1>
<select id="categoryFilter" onchange="filter()">
	@foreach(var category in @ViewBag.cateFilter)
	{
		<option value="@category.CategoryId">@category.CategoryName</option>
	}
</select>

<h1>List Of Products</h1>
<table>
	<thead>
		<tr>
			<th>Id</th>
			<th>Name</th>
			<th>Price</th>
			<th>Stock</th>
			<th>Image</th>
			<th>CategoryName</th>
			<th>Delete</th>
		</tr>
	</thead>
	<tbody id="productTableBody">
		@foreach(var item in ViewBag.list)
		{
			<tr>
				<td><a href="javascript:void(0)" onclick="showProductDetail(@item.ProductId)">@item.ProductId</a></td>
				<td>@item.ProductName</td>
				<td>@item.UnitPrice</td>
				<td>@item.UnitsInStock</td>
				<td>@item.Image</td>
				<td>@item.Category.CategoryName</td>
				<td><a href="javascript:void(0)" onclick="deleteProduct(@item.ProductId)">Delete</a></td>
			</tr>
		}
	</tbody>
</table>
<h2>Information of products</h2>
<form>
	<table>
		<tbody>
			<tr>
				<td>Id:</td>
				<td><input type="text" id="productId" readonly /></td>
			</tr>
			<tr>
				<td>Name:</td>
				<td><input type="text" id="productName" /></td>
			</tr>
			<tr>
				<td>Price:</td>
				<td><input type="text" id="productPrice" /></td>
			</tr>
			<tr>
				<td>Stock:</td>
				<td><input type="text" id="productStock" /></td>
			</tr>
			<tr>
				<td>Image:</td>
				<td><input type="text" id="productImage" /></td>
			</tr>
			<tr>
				<td>Category</td>
				<td><select id="categorySelect">
						@foreach(var category in @ViewBag.cate)
						{
							<option value="@category.CategoryId">@category.CategoryName</option>
						}
					</select></td>
			</tr>
		</tbody>
	</table>
	<button type="button" onclick="addProduct()">Add</button>
	<button type="button" onclick="updateProduct()">Update</button>
</form>
